Package com.ngrok.services

# Class ReservedDomains.CreateCallBuilder

java.lang.Object
com.ngrok.services.ReservedDomains.CreateCallBuilder

Enclosing class:
  ReservedDomains

public class ReservedDomains.CreateCallBuilder extends Object
A builder object encapsulating state for an unsent Create API call.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ReservedDomain`
  `blockingCall()`
  Initiates the API call and blocks until it returns.
  `CompletionStage<ReservedDomain>`
  `call()`
  Initiates the API call asynchronously.
  `ReservedDomains.CreateCallBuilder`
  `certificateId(String certificateId)`
  ID of a user-uploaded TLS certificate to use for connections to targeting this domain.
  `ReservedDomains.CreateCallBuilder`
  `certificateId(Optional<String> certificateId)`
  ID of a user-uploaded TLS certificate to use for connections to targeting this domain.
  `ReservedDomains.CreateCallBuilder`
  `certificateManagementPolicy(ReservedDomainCertPolicy certificateManagementPolicy)`
  configuration for automatic management of TLS certificates for this domain, or null if automatic management is disabled.
  `ReservedDomains.CreateCallBuilder`
  `certificateManagementPolicy(Optional<ReservedDomainCertPolicy> certificateManagementPolicy)`
  configuration for automatic management of TLS certificates for this domain, or null if automatic management is disabled.
  `ReservedDomains.CreateCallBuilder`
  `description(String description)`
  human-readable description of what this reserved domain will be used for
  `ReservedDomains.CreateCallBuilder`
  `description(Optional<String> description)`
  human-readable description of what this reserved domain will be used for
  `ReservedDomains.CreateCallBuilder`
  `metadata(String metadata)`
  arbitrary user-defined machine-readable data of this reserved domain.
  `ReservedDomains.CreateCallBuilder`
  `metadata(Optional<String> metadata)`
  arbitrary user-defined machine-readable data of this reserved domain.
  `ReservedDomains.CreateCallBuilder`
  `region(String region)`
  reserve the domain in this geographic ngrok datacenter.
  `ReservedDomains.CreateCallBuilder`
  `region(Optional<String> region)`
  reserve the domain in this geographic ngrok datacenter.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### region

    public ReservedDomains.CreateCallBuilder region(String region)
    reserve the domain in this geographic ngrok datacenter. Optional, default is us. (au, eu, ap, us, jp, in, sa)
    Parameters:
      `region` - the value of the region parameter as a `String`
    Returns:
      the call builder instance

  - ### region

    public ReservedDomains.CreateCallBuilder region(Optional<String> region)
    reserve the domain in this geographic ngrok datacenter. Optional, default is us. (au, eu, ap, us, jp, in, sa)
    Parameters:
      `region` - the value of the region parameter as an `Optional` of `String`
    Returns:
      the call builder instance

  - ### description

    public ReservedDomains.CreateCallBuilder description(String description)
    human-readable description of what this reserved domain will be used for
    Parameters:
      `description` - the value of the description parameter as a `String`
    Returns:
      the call builder instance

  - ### description

    public ReservedDomains.CreateCallBuilder description(Optional<String> description)
    human-readable description of what this reserved domain will be used for
    Parameters:
      `description` - the value of the description parameter as an `Optional` of `String`
    Returns:
      the call builder instance

  - ### metadata

    public ReservedDomains.CreateCallBuilder metadata(String metadata)
    arbitrary user-defined machine-readable data of this reserved domain. Optional, max 4096 bytes.
    Parameters:
      `metadata` - the value of the metadata parameter as a `String`
    Returns:
      the call builder instance

  - ### metadata

    public ReservedDomains.CreateCallBuilder metadata(Optional<String> metadata)
    arbitrary user-defined machine-readable data of this reserved domain. Optional, max 4096 bytes.
    Parameters:
      `metadata` - the value of the metadata parameter as an `Optional` of `String`
    Returns:
      the call builder instance

  - ### certificateId

    public ReservedDomains.CreateCallBuilder certificateId(String certificateId)
    ID of a user-uploaded TLS certificate to use for connections to targeting this domain. Optional, mutually exclusive with `certificate_management_policy`.
    Parameters:
      `certificateId` - the value of the certificate_id parameter as a `String`
    Returns:
      the call builder instance

  - ### certificateId

    public ReservedDomains.CreateCallBuilder certificateId(Optional<String> certificateId)
    ID of a user-uploaded TLS certificate to use for connections to targeting this domain. Optional, mutually exclusive with `certificate_management_policy`.
    Parameters:
      `certificateId` - the value of the certificate_id parameter as an `Optional` of `String`
    Returns:
      the call builder instance

  - ### certificateManagementPolicy

    public ReservedDomains.CreateCallBuilder certificateManagementPolicy(ReservedDomainCertPolicy certificateManagementPolicy)
    configuration for automatic management of TLS certificates for this domain, or null if automatic management is disabled. Optional, mutually exclusive with `certificate_id`.
    Parameters:
      `certificateManagementPolicy` - the value of the certificate_management_policy parameter as a `ReservedDomainCertPolicy`
    Returns:
      the call builder instance

  - ### certificateManagementPolicy

    public ReservedDomains.CreateCallBuilder certificateManagementPolicy(Optional<ReservedDomainCertPolicy> certificateManagementPolicy)
    configuration for automatic management of TLS certificates for this domain, or null if automatic management is disabled. Optional, mutually exclusive with `certificate_id`.
    Parameters:
      `certificateManagementPolicy` - the value of the certificate_management_policy parameter as an `Optional` of `ReservedDomainCertPolicy`
    Returns:
      the call builder instance

  - ### call

    public CompletionStage<ReservedDomain> call()
    Initiates the API call asynchronously.
    Returns:
      a `CompletionStage` of `ReservedDomain`

  - ### blockingCall

    public ReservedDomain blockingCall() throws InterruptedException
    Initiates the API call and blocks until it returns.
    Returns:
      `ReservedDomain`
    Throws:
      `InterruptedException` - if the thread was interrupted during the call